VERSION 5.00
Begin VB.UserControl InputBox 
   CanGetFocus     =   0   'False
   ClientHeight    =   264
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   288
   InvisibleAtRuntime=   -1  'True
   Picture         =   "InputBox.ctx":0000
   PropertyPages   =   "InputBox.ctx":018A
   ScaleHeight     =   264
   ScaleWidth      =   288
   ToolboxBitmap   =   "InputBox.ctx":01D1
End
Attribute VB_Name = "InputBox"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "PropPageWizardRun" ,"Yes"
Option Explicit


Private Const PROPDEFAULT_ALLOWDASH As Boolean = False
Private Const PROPDEFAULT_ALLOWDOLLARSIGN As Boolean = False
Private Const PROPDEFAULT_ALLOWDECIMALPOINT As Boolean = False
Private Const PROPDEFAULT_ALLOWCOMMA As Boolean = False
Private Const PROPDEFAULT_ALLOWNEGATIVESIGN As Boolean = False
Private Const PROPDEFAULT_ALLOWPOSITIVESIGN As Boolean = False
Private Const PROPDEFAULT_ALLOWSLASH As Boolean = False
Private Const PROPDEFAULT_ALPHAONLY As Boolean = False
Private Const PROPDEFAULT_AUTOSELECTTEXT As Boolean = False
Private Const PROPDEFAULT_DEFAULTVALUE As Variant = ""
Private Const PROPDEFAULT_FORCEUPPERCASE As Boolean = False
Private Const PROPDEFAULT_HIGHLIGHTONFOCUS As Boolean = False
Private Const PROPDEFAULT_HIGHLIGHTCOLOR As Long = vbYellow
Private Const PROPDEFAULT_MAXLENGTH As Integer = 0
Private Const PROPDEFAULT_MAXDECIMALPLACES As Long = -1
Private Const PROPDEFAULT_NUMERICONLY As Boolean = False
Private Const PROPDEFAULT_OK As Boolean = False
Private Const PROPDEFAULT_PASSWORDCHAR As String = ""
Private Const PROPDEFAULT_PROMPT As String = ""
Private Const PROPDEFAULT_TEXTALIGNMENT As Long = vbLeftJustify
Private Const PROPDEFAULT_TITLEBARCAPTION As String = ""
Private Const PROPDEFAULT_TOOLTIPTEXT As String = ""



Private mvarAllowDash As Boolean
Private mvarAllowDollarSign As Boolean
Private mvarAllowDecimalPoint As Boolean
Private mvarAllowComma As Boolean
Private mvarAllowNegativeSign As Boolean
Private mvarAllowPositiveSign As Boolean
Private mvarAllowSlash As Boolean
Private mvarAlphaOnly As Boolean
Private mvarAutoSelectText As Boolean
Private mvarDefaultValue As Variant
Private mvarHighlightOnFocus As Boolean
Private mvarHighlightColor As OLE_COLOR
Private mvarMaxLength As Integer
Private mvarMaxDecimalPlaces As Long
Private mvarNumericOnly As Boolean
Private mvarPrompt As String
Private mvarPasswordChar As String
Private mvarTextAlignment As AlignmentConstants
Private mvarTitleBarCaption As String
Private mvarToolTipText As String
Private mvarForceUpperCase As Boolean


'*****************************************************
'* PROPERTIES                                        *
'*****************************************************

Public Property Let AllowComma(vdata As Boolean)
  mvarAllowComma = vdata
  frmInputBox.AllowComma = mvarAllowComma
  PropertyChanged "AllowComma"
End Property

Public Property Get AllowComma() As Boolean
Attribute AllowComma.VB_Description = "Allows the user to enter a comma when NumericOnly is set to True"
Attribute AllowComma.VB_ProcData.VB_Invoke_Property = ";Behavior"
  AllowComma = mvarAllowComma
End Property

Public Property Let AllowDash(vdata As Boolean)
  mvarAllowDash = vdata
  frmInputBox.AllowDash = mvarAllowDash
  PropertyChanged "AllowDash"
End Property

Public Property Get AllowDash() As Boolean
Attribute AllowDash.VB_Description = "Allows the user to enter a dash when NumericOnly is set to True"
Attribute AllowDash.VB_ProcData.VB_Invoke_Property = ";Behavior"
  AllowDash = mvarAllowDash
End Property

Public Property Let AllowDecimalPoint(vdata As Boolean)
  mvarAllowDecimalPoint = vdata
  frmInputBox.AllowDecimalPoint = mvarAllowDecimalPoint
  PropertyChanged "AllowDecimalPoint"
End Property

Public Property Get AllowDecimalPoint() As Boolean
Attribute AllowDecimalPoint.VB_Description = "Allows the user to enter a decimal point when NumericOnly is set to True"
Attribute AllowDecimalPoint.VB_ProcData.VB_Invoke_Property = ";Behavior"
  AllowDecimalPoint = mvarAllowDecimalPoint
End Property

Public Property Let AllowDollarSign(vdata As Boolean)
  mvarAllowDollarSign = vdata
  frmInputBox.AllowDollarSign = mvarAllowDollarSign
  PropertyChanged "AllowDollarSign"
End Property

Public Property Get AllowDollarSign() As Boolean
Attribute AllowDollarSign.VB_Description = "Allows the user to enter a dollar sign when NumericOnly is set to True"
Attribute AllowDollarSign.VB_ProcData.VB_Invoke_Property = ";Behavior"
  AllowDollarSign = mvarAllowDollarSign
End Property

Public Property Let AllowNegativeSign(vdata As Boolean)
  mvarAllowNegativeSign = vdata
  frmInputBox.AllowNegativeSign = mvarAllowNegativeSign
  PropertyChanged "AllowNegativeSign"
End Property

Public Property Get AllowNegativeSign() As Boolean
Attribute AllowNegativeSign.VB_Description = "Allows the user to enter a negative sign when NumericOnly is set to True"
Attribute AllowNegativeSign.VB_ProcData.VB_Invoke_Property = ";Behavior"
  AllowNegativeSign = mvarAllowNegativeSign
End Property

Public Property Let AllowPositiveSign(vdata As Boolean)
  mvarAllowPositiveSign = vdata
  frmInputBox.AllowPositiveSign = mvarAllowPositiveSign
  PropertyChanged "AllowPositiveSign"
End Property

Public Property Get AllowPositiveSign() As Boolean
Attribute AllowPositiveSign.VB_Description = "Allows the user to enter a positive sign when NumericOnly is set to True"
Attribute AllowPositiveSign.VB_ProcData.VB_Invoke_Property = ";Behavior"
  AllowPositiveSign = mvarAllowPositiveSign
End Property

Public Property Let AllowSlash(vdata As Boolean)
  mvarAllowSlash = vdata
  frmInputBox.AllowSlash = mvarAllowSlash
  PropertyChanged "AllowSlash"
End Property

Public Property Get AllowSlash() As Boolean
Attribute AllowSlash.VB_Description = "Allows the user to enter a forward slash when NumericOnly is set to True"
Attribute AllowSlash.VB_ProcData.VB_Invoke_Property = ";Behavior"
  AllowSlash = mvarAllowSlash
End Property

Public Property Let AlphaOnly(vdata As Boolean)
  mvarAlphaOnly = vdata
  frmInputBox.AlphaOnly = mvarAlphaOnly
  PropertyChanged "AlphaOnly"
  
  If vdata = True Then
    Me.NumericOnly = False
  End If
  
End Property

Public Property Get AlphaOnly() As Boolean
Attribute AlphaOnly.VB_Description = "Only allows the user to enter alphabetic data"
Attribute AlphaOnly.VB_ProcData.VB_Invoke_Property = ";Behavior"
  AlphaOnly = mvarAlphaOnly
End Property

Public Property Let AutoSelectText(vdata As Boolean)
  mvarAutoSelectText = vdata
  frmInputBox.AutoSelectText = mvarAutoSelectText
  PropertyChanged "AutoSelectText"
End Property

Public Property Get AutoSelectText() As Boolean
Attribute AutoSelectText.VB_Description = "Automatically selects the text whenever the text box gets focus"
Attribute AutoSelectText.VB_ProcData.VB_Invoke_Property = ";Behavior"
   AutoSelectText = mvarAutoSelectText
End Property

Public Property Let DefaultValue(vdata As Variant)
  mvarDefaultValue = vdata
  frmInputBox.Text1 = mvarDefaultValue
  PropertyChanged "DefaultValue"
End Property

Public Property Get DefaultValue() As Variant
Attribute DefaultValue.VB_Description = "The default value of the InputBoxControl"
Attribute DefaultValue.VB_ProcData.VB_Invoke_Property = ";Misc"
  DefaultValue = mvarDefaultValue
End Property

Public Property Let MaxDecimalPlaces(vdata As Long)
  mvarMaxDecimalPlaces = vdata
  frmInputBox.MaxDecimalPlaces = mvarMaxDecimalPlaces
  PropertyChanged "MaxDecimalPlaces"
End Property

Public Property Get MaxDecimalPlaces() As Long
Attribute MaxDecimalPlaces.VB_ProcData.VB_Invoke_Property = ";Behavior"
  MaxDecimalPlaces = mvarMaxDecimalPlaces
End Property

Public Property Let MaxLength(vdata As Integer)
  mvarMaxLength = vdata
  frmInputBox.Text1.MaxLength = mvarMaxLength
  PropertyChanged "MaxLength"
End Property

Public Property Get MaxLength() As Integer
Attribute MaxLength.VB_ProcData.VB_Invoke_Property = ";Behavior"
  MaxLength = mvarMaxLength
End Property

Public Property Let NumericOnly(vdata As Boolean)
  mvarNumericOnly = vdata
  frmInputBox.NumericOnly = mvarNumericOnly
  PropertyChanged "NumericOnly"
  
  If vdata = True Then
    Me.AlphaOnly = False
  End If

End Property

Public Property Get NumericOnly() As Boolean
Attribute NumericOnly.VB_ProcData.VB_Invoke_Property = ";Behavior"
  NumericOnly = mvarNumericOnly
End Property

Public Property Let TextAlignment(vdata As AlignmentConstants)
  mvarTextAlignment = vdata
  frmInputBox.Text1.Alignment = mvarTextAlignment
  PropertyChanged "TextAlignment"
End Property

Public Property Get TextAlignment() As AlignmentConstants
Attribute TextAlignment.VB_ProcData.VB_Invoke_Property = ";Appearance"
  TextAlignment = mvarTextAlignment
End Property

Public Property Let TitleBarCaption(vdata As String)
  mvarTitleBarCaption = vdata
  frmInputBox.Caption = mvarTitleBarCaption
  PropertyChanged "TitleBarCaption"
End Property

Public Property Get TitleBarCaption() As String
Attribute TitleBarCaption.VB_ProcData.VB_Invoke_Property = ";Misc"
  TitleBarCaption = mvarTitleBarCaption
End Property

Public Property Let ToolTipText(vdata As String)
  mvarToolTipText = vdata
  frmInputBox.Text1.ToolTipText = mvarToolTipText
  PropertyChanged "ToolTipText"
End Property

Public Property Get ToolTipText() As String
Attribute ToolTipText.VB_ProcData.VB_Invoke_Property = ";Misc"
  ToolTipText = mvarToolTipText
End Property

Public Property Let Prompt(vdata As String)
  mvarPrompt = vdata
  frmInputBox.lblPrompt = mvarPrompt
  PropertyChanged "Prompt"
End Property

Public Property Get Prompt() As String
Attribute Prompt.VB_ProcData.VB_Invoke_Property = ";Misc"
  Prompt = mvarPrompt
End Property

Public Property Let ForceUpperCase(vdata As Boolean)
  mvarForceUpperCase = vdata
  frmInputBox.ForceUpperCase = mvarForceUpperCase
  PropertyChanged "ForceUpperCase"
  
  If vdata = True Then
    Me.NumericOnly = False
  End If
End Property

Public Property Get ForceUpperCase() As Boolean
Attribute ForceUpperCase.VB_Description = "Forces uppercase of all letters entered by the user."
Attribute ForceUpperCase.VB_ProcData.VB_Invoke_Property = ";Behavior"
  ForceUpperCase = mvarForceUpperCase
End Property

Public Property Get OK() As Boolean
  OK = frmInputBox.OK
End Property

Public Property Let HighlightColor(vdata As OLE_COLOR)
  mvarHighlightColor = vdata
  frmInputBox.HighlightColor = mvarHighlightColor
  PropertyChanged "HighlightColor"
End Property

Public Property Get HighlightColor() As OLE_COLOR
Attribute HighlightColor.VB_ProcData.VB_Invoke_Property = "StandardColor;Appearance"
Attribute HighlightColor.VB_MemberFlags = "400"
  HighlightColor = mvarHighlightColor
End Property

Public Property Let HighlightOnFocus(vdata As Boolean)
  mvarHighlightOnFocus = vdata
  frmInputBox.HighlightOnFocus = mvarHighlightOnFocus
  PropertyChanged "HighlightOnFocus"
End Property

Public Property Get HighlightOnFocus() As Boolean
Attribute HighlightOnFocus.VB_ProcData.VB_Invoke_Property = ";Appearance"
  HighlightOnFocus = mvarHighlightOnFocus
End Property

Public Property Get Value() As Variant
Attribute Value.VB_UserMemId = 0
  Value = frmInputBox.Value
End Property

Public Property Let PasswordChar(Character As String)
  mvarPasswordChar = Character
  frmInputBox.Text1.PasswordChar = mvarPasswordChar
  PropertyChanged "PasswordChar"
End Property

Public Property Get PasswordChar() As String
Attribute PasswordChar.VB_ProcData.VB_Invoke_Property = ";Misc"
  PasswordChar = mvarPasswordChar
End Property



'*****************************************************
'* METHODS                                           *
'*****************************************************
Public Sub Show(Optional ByVal Modality As FormShowConstants, Optional ByVal OwnerForm As Object)
  frmInputBox.OK = False
  frmInputBox.Show Modality, OwnerForm
End Sub

Public Sub Initialize()

  With Me
    .AllowDash = PROPDEFAULT_ALLOWDASH
    .AllowDollarSign = PROPDEFAULT_ALLOWDOLLARSIGN
    .AllowDecimalPoint = PROPDEFAULT_ALLOWDECIMALPOINT
    .AllowComma = PROPDEFAULT_ALLOWCOMMA
    .AllowNegativeSign = PROPDEFAULT_ALLOWNEGATIVESIGN
    .AllowPositiveSign = PROPDEFAULT_ALLOWPOSITIVESIGN
    .AllowSlash = PROPDEFAULT_ALLOWSLASH
    .AlphaOnly = PROPDEFAULT_ALPHAONLY
    .AutoSelectText = PROPDEFAULT_AUTOSELECTTEXT
    .DefaultValue = PROPDEFAULT_DEFAULTVALUE
    .ForceUpperCase = PROPDEFAULT_FORCEUPPERCASE
    .HighlightOnFocus = PROPDEFAULT_HIGHLIGHTONFOCUS
    .HighlightColor = PROPDEFAULT_HIGHLIGHTCOLOR
    .MaxLength = PROPDEFAULT_MAXLENGTH
    .MaxDecimalPlaces = PROPDEFAULT_MAXDECIMALPLACES
    .NumericOnly = PROPDEFAULT_NUMERICONLY
    .PasswordChar = PROPDEFAULT_PASSWORDCHAR
    .Prompt = PROPDEFAULT_PROMPT
    .TextAlignment = PROPDEFAULT_TEXTALIGNMENT
    .TitleBarCaption = PROPDEFAULT_TITLEBARCAPTION
    .ToolTipText = PROPDEFAULT_TOOLTIPTEXT
  End With
  
End Sub

Private Sub UserControl_InitProperties()
  AllowComma = PROPDEFAULT_ALLOWCOMMA
  AllowDash = PROPDEFAULT_ALLOWDASH
  AllowDecimalPoint = PROPDEFAULT_ALLOWDECIMALPOINT
  AllowDollarSign = PROPDEFAULT_ALLOWDOLLARSIGN
  AllowNegativeSign = PROPDEFAULT_ALLOWNEGATIVESIGN
  AllowPositiveSign = PROPDEFAULT_ALLOWPOSITIVESIGN
  AllowSlash = PROPDEFAULT_ALLOWSLASH
  AlphaOnly = PROPDEFAULT_ALPHAONLY
  AutoSelectText = PROPDEFAULT_AUTOSELECTTEXT
  DefaultValue = PROPDEFAULT_DEFAULTVALUE
  ForceUpperCase = PROPDEFAULT_FORCEUPPERCASE
  HighlightColor = PROPDEFAULT_HIGHLIGHTCOLOR
  HighlightOnFocus = PROPDEFAULT_HIGHLIGHTONFOCUS
  MaxDecimalPlaces = PROPDEFAULT_MAXDECIMALPLACES
  MaxLength = PROPDEFAULT_MAXLENGTH
  NumericOnly = PROPDEFAULT_NUMERICONLY
  PasswordChar = PROPDEFAULT_PASSWORDCHAR
  Prompt = PROPDEFAULT_PROMPT
  TextAlignment = PROPDEFAULT_TEXTALIGNMENT
  TitleBarCaption = PROPDEFAULT_TITLEBARCAPTION
  ToolTipText = PROPDEFAULT_TOOLTIPTEXT
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
  On Error Resume Next
  
  With PropBag
    AllowComma = .ReadProperty("AllowComma", PROPDEFAULT_ALLOWCOMMA)
    AllowDash = .ReadProperty("AllowDash", PROPDEFAULT_ALLOWDASH)
    AllowDecimalPoint = .ReadProperty("AllowDecimalPoint", PROPDEFAULT_ALLOWDECIMALPOINT)
    AllowDollarSign = .ReadProperty("AllowDollarSign", PROPDEFAULT_ALLOWDOLLARSIGN)
    AllowNegativeSign = .ReadProperty("AllowNegativeSign", PROPDEFAULT_ALLOWNEGATIVESIGN)
    AllowPositiveSign = .ReadProperty("AllowPositiveSign", PROPDEFAULT_ALLOWPOSITIVESIGN)
    AllowSlash = .ReadProperty("AllowSlash", PROPDEFAULT_ALLOWSLASH)
    AlphaOnly = .ReadProperty("AlphaOnly", PROPDEFAULT_ALPHAONLY)
    AutoSelectText = .ReadProperty("AutoSelectText", PROPDEFAULT_AUTOSELECTTEXT)
    DefaultValue = .ReadProperty("DefaultValue", PROPDEFAULT_DEFAULTVALUE)
    ForceUpperCase = .ReadProperty("ForceUpperCase", PROPDEFAULT_FORCEUPPERCASE)
    HighlightColor = .ReadProperty("HighlightColor", PROPDEFAULT_HIGHLIGHTCOLOR)
    HighlightOnFocus = .ReadProperty("HighlightOnFocus", PROPDEFAULT_HIGHLIGHTONFOCUS)
    MaxDecimalPlaces = .ReadProperty("MaxDecimalPlaces", PROPDEFAULT_MAXDECIMALPLACES)
    MaxLength = .ReadProperty("MaxLength", PROPDEFAULT_MAXLENGTH)
    NumericOnly = .ReadProperty("NumericOnly", PROPDEFAULT_NUMERICONLY)
    PasswordChar = .ReadProperty("PasswordChar", PROPDEFAULT_PASSWORDCHAR)
    Prompt = .ReadProperty("Prompt", PROPDEFAULT_PROMPT)
    TextAlignment = .ReadProperty("TextAlignment", PROPDEFAULT_TEXTALIGNMENT)
    TitleBarCaption = .ReadProperty("TitleBarCaption", PROPDEFAULT_TITLEBARCAPTION)
    ToolTipText = .ReadProperty("ToolTipText", PROPDEFAULT_TOOLTIPTEXT)
  End With
End Sub

Private Sub UserControl_Resize()
  Size 290, 264
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
  
  With PropBag
    Call .WriteProperty("AllowComma", mvarAllowComma, PROPDEFAULT_ALLOWCOMMA)
    Call .WriteProperty("AllowDash", mvarAllowDash, PROPDEFAULT_ALLOWDASH)
    Call .WriteProperty("AllowDecimalPoint", mvarAllowDecimalPoint, PROPDEFAULT_ALLOWDECIMALPOINT)
    Call .WriteProperty("AllowDollarSign", mvarAllowDollarSign, PROPDEFAULT_ALLOWDOLLARSIGN)
    Call .WriteProperty("AllowNegativeSign", mvarAllowNegativeSign, PROPDEFAULT_ALLOWNEGATIVESIGN)
    Call .WriteProperty("AllowPositiveSign", mvarAllowPositiveSign, PROPDEFAULT_ALLOWPOSITIVESIGN)
    Call .WriteProperty("AllowSlash", mvarAllowSlash, PROPDEFAULT_ALLOWSLASH)
    Call .WriteProperty("AlphaOnly", mvarAlphaOnly, PROPDEFAULT_ALPHAONLY)
    Call .WriteProperty("AutoSelectText", mvarAutoSelectText, PROPDEFAULT_AUTOSELECTTEXT)
    Call .WriteProperty("DefaultValue", mvarDefaultValue, PROPDEFAULT_DEFAULTVALUE)
    Call .WriteProperty("ForceUpperCase", mvarForceUpperCase, PROPDEFAULT_FORCEUPPERCASE)
    Call .WriteProperty("HighlightColor", mvarHighlightColor, PROPDEFAULT_HIGHLIGHTCOLOR)
    Call .WriteProperty("HighlightOnFocus", mvarHighlightOnFocus, PROPDEFAULT_HIGHLIGHTONFOCUS)
    Call .WriteProperty("MaxDecimalPlaces", mvarMaxDecimalPlaces, PROPDEFAULT_MAXDECIMALPLACES)
    Call .WriteProperty("MaxLength", mvarMaxLength, PROPDEFAULT_MAXLENGTH)
    Call .WriteProperty("NumericOnly", mvarNumericOnly, PROPDEFAULT_NUMERICONLY)
    Call .WriteProperty("PasswordChar", mvarPasswordChar, PROPDEFAULT_PASSWORDCHAR)
    Call .WriteProperty("Prompt", mvarPrompt, PROPDEFAULT_PROMPT)
    Call .WriteProperty("TextAlignment", mvarTextAlignment, PROPDEFAULT_TEXTALIGNMENT)
    Call .WriteProperty("TitleBarCaption", mvarTitleBarCaption, PROPDEFAULT_TITLEBARCAPTION)
    Call .WriteProperty("ToolTipText", mvarToolTipText, PROPDEFAULT_TOOLTIPTEXT)
  End With
End Sub
